#!/bin/bash

CONF=/usr/local/conf/httpd.conf
TMP=/tmp/httpd.conf

pushd `dirname $0` > /dev/null
SCRIPTPATH=`pwd`
popd > /dev/null

MDIR="${SCRIPTPATH}/metadata"
ODIR=`tail -n 1 ${CONF} | cut -d" " -f2`

function restart() {
  sudo /usr/local/bin/apachectl restart
  #PROCS=`ps aux | grep [v]algrind.bin | awk '{print $2}'`
  #if [ -n "${PROCS}" ] ; then sudo kill ${PROCS} ; fi
  #source /usr/local/bin/envvars
  #sudo valgrind --leak-check=full --log-file=valgrind-${1}.log /usr/local/bin/httpd
}

function rollover() {
  cat ${CONF} | sed '$ d' > ${TMP}
  echo "OIDCMetadataDir ${1}" >> ${TMP}
  sudo mv ${TMP} ${CONF}
  restart "${2}"
}

./oidc-rp-certification.sh clean

TESTS=$1
if [ -z ${TESTS} ] ; then
	TESTS=`cd metadata && find * -maxdepth 0 -type d | sort`
fi
TOTAL=`echo ${TESTS} | wc -w`
NR=0
for PROFILE in ${TESTS} ; do
	rollover "${MDIR}/${PROFILE}" "${PROFILE}"
	./oidc-rp-certification.sh ${PROFILE} || exit
	NR=$((NR+1))
done

echo ""
printf " # SUCCESS: accumulated profile coverage %.2f%% (%d/%d)\n" `echo "100 * ${NR} / ${TOTAL}" | bc -l` ${NR} ${TOTAL}
echo ""	

rollover "${ODIR}" "normal"
